<id>
Pie Chart for Polls in YaBB 2.2.1
</id>

<version>
1.1
</version>

<mod info>

Apply this mod.

This mod will enable users to see the poll result as a Pie Chart.

The Poll-author can:
- select the color for each pie slice
- choose if the option-text and vote-results should be shown as labels next to each pie slice (default) or as legends next to the pie chart
- change the radiud for the pie
- split one or more slices from the pie (explode)

Upload (in ASCII mode):

cgi-bin/yabb2/Admin/ModList.pl
cgi-bin/yabb2/Languages/English/Post.lng
cgi-bin/yabb2/Sources/ModifyMessage.pl
cgi-bin/yabb2/Sources/Poll.pl
cgi-bin/yabb2/Sources/Post.pl


Upload from this package (in ASCII mode):

public_html/yabbfiles/piechart.js


Upload (in Binary mode):

public_html/yabbfiles/ModImages/pollpie/*.gif

</mod info>

<author>
Carsten
</author>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$pollpie_mod = "Pie chart for Polls|Carsten|This mod will enable users to see the poll result as a Pie Chart.|1.1|03/24/08";
	push (@installed_mods, "$pollpie_mod");

</add before>


<Edit file>
Languages/English/Post.lng
</Edit file>

<search for>
'62' => 'In the time limit field.',
</search for>

<add after>
'polloptions' => 'Options:',
'polloptionstext' => 'Text',
'pieslicecolor' => 'Color',
'pieslicesplit' => 'Split Pie',
'pieradius' => 'Pie Chart Radius:',
'pieradius_descr' => 'Must be a value between 100 and 200 (default 100)',
'pielegends' => 'Use legends for Pie Chart',
'pielegends_descr' => 'Check this to use legends instead of labels next to each pie slice.',
</add after>

<Edit file>
Sources/ModifyMessage.pl
</Edit file>

<search for>
		($poll_question, $poll_locked, $poll_uname, $poll_name, $poll_email, $poll_date, $guest_vote, $hide_results, $multi_choice, $poll_mod, $poll_modname, $poll_comment, $vote_limit) = split(/\|/, $poll_data[0]);
</search for>

<replace>
		($poll_question, $poll_locked, $poll_uname, $poll_name, $poll_email, $poll_date, $guest_vote, $hide_results, $multi_choice, $poll_mod, $poll_modname, $poll_comment, $vote_limit, $pie_radius, $pie_legends) = split(/\|/, $poll_data[0]);
</replace>

<search for>
			($votes[$i], $options[$i]) = split(/\|/, $poll_data[$i]);
</search for>

<replace>
			($votes[$i], $options[$i], $slicecolor[$i], $split[$i]) = split(/\|/, $poll_data[$i]);
</replace>

<search for>
		$vote_limit   = $FORM{'vote_limit'}   || 0;
</search for>

<add after>
		$pie_legends  = $FORM{'pie_legends'}  || 0;
		$pie_radius   = $FORM{'pie_radius'}   || 100;

		if ($pie_radius =~ /\D/) { $pie_radius = 100; }
		if ($pie_radius < 100) { $pie_radius = 100; }
		if ($pie_radius > 200) { $pie_radius = 200; }
</add after>

<search for>
		push @new_poll_data, qq~$poll_question|$poll_locked|$poll_uname|$poll_name|$poll_email|$poll_date|$guest_vote|$hide_results|$multi_choice|$date|$username|$poll_comment|$vote_limit\n~;
</search for>

<replace>
		push @new_poll_data, qq~$poll_question|$poll_locked|$poll_uname|$poll_name|$poll_email|$poll_date|$guest_vote|$hide_results|$multi_choice|$date|$username|$poll_comment|$vote_limit|$pie_radius|$pie_legends\n~;
</replace>

<search for>
				push @new_poll_data, qq~$votes|$FORM{"option$i"}\n~;
</search for>

<replace>
				push @new_poll_data, qq~$votes|$FORM{"option$i"}|$FORM{"slicecol$i"}|$FORM{"split$i"}\n~;
</replace>


<Edit file>
Sources/Poll.pl
</Edit file>

<search for>
		($votes[$i], $options[$i]) = split(/\|/, $poll_data[$i]);
		$tmp_vote = qq~$FORM{"option$i"}~;
</search for>

<replace>
		($votes[$i], $options[$i], $slicecols[$i], $split[$i]) = split(/\|/, $poll_data[$i]);
		$tmp_vote = qq~$FORM{"option$i"}~;
</replace>

<search for>
			last;
		}
	}

	fopen(FILE, ">$datadir/$pollnum.poll");
	print FILE "$poll_question\n";
	for (my $i = 0; $i < @poll_data; $i++) { print FILE "$votes[$i]|$options[$i]\n"; }
</search for>

<replace>
			last;
		}
	}

	fopen(FILE, ">$datadir/$pollnum.poll");
	print FILE "$poll_question\n";
	for (my $i = 0; $i < @poll_data; $i++) { print FILE "$votes[$i]|$options[$i]|$slicecols[$i]|$split[$i]\n"; }
</replace>

<search for>
	for (my $i = 0; $i < @poll_data; $i++) {
		chomp $poll_data[$i];
		($votes[$i], $options[$i]) = split(/\|/, $poll_data[$i]);
	}
</search for>

<replace>
	for (my $i = 0; $i < @poll_data; $i++) {
		chomp $poll_data[$i];
		($votes[$i], $options[$i], $slicecols[$i], $split[$i]) = split(/\|/, $poll_data[$i]);
	}
</replace>

<search for>
		if (!$found) { &fatal_error('not_completed'); }
	}

	fopen(FILE, ">$datadir/$pollnum.poll");
	print FILE "$poll_question\n";
	for (my $i = 0; $i < @poll_data; $i++) { print FILE "$votes[$i]|$options[$i]\n"; }
</search for>

<replace>
		if (!$found) { &fatal_error('not_completed'); }
	}

	fopen(FILE, ">$datadir/$pollnum.poll");
	print FILE "$poll_question\n";
	for (my $i = 0; $i < @poll_data; $i++) { print FILE "$votes[$i]|$options[$i]|$slicecols[$i]|$split[$i]\n"; }
</replace>

<search for>
	($poll_question, $poll_locked, $poll_uname, $poll_name, $poll_email, $poll_date, $guest_vote, $hide_results, $multi_vote, $poll_mod, $poll_modname, $poll_comment) = split(/\|/, $poll_question);

	$users_votetext = '';
</search for>

<replace>
	($poll_question, $poll_locked, $poll_uname, $poll_name, $poll_email, $poll_date, $guest_vote, $hide_results, $multi_vote, $poll_mod, $poll_modname, $poll_comment, $vote_limit, $pie_radius, $pie_legends) = split(/\|/, $poll_question);
	$pie_radius ||= 100;

	$users_votetext = '';
</replace>

<search for>
	for (my $i = 0; $i < @poll_data; $i++) {
		chomp $poll_data[$i];
		($votes[$i], $options[$i]) = split(/\|/, $poll_data[$i]);
		&ToChars($options[$i]);
		$totalvotes += int($votes[$i]);
		if (int($votes[$i]) >= $maxvote) { $maxvote = int($votes[$i]); }
	}
</search for>

<replace>
	$piearray = qq~[~;
	for (my $i = 0; $i < @poll_data; $i++) {
		chomp $poll_data[$i];
		($votes[$i], $options[$i], $slicecolor[$i], $split[$i]) = split(/\|/, $poll_data[$i]);
		# Censor the options.
		$options[$i] = &Censor($options[$i]);
		$options[$i] =~ s~[\n\r]~~g;
		if ($ubbcpolls) {
			if (!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
			$message = $options[$i];
			&DoUBBC;
			$options[$i] = $message;
		}
		&ToChars($options[$i]);
		$piearray .= qq~"$votes[$i]|$options[$i]|$slicecolor[$i]|$split[$i]", ~;
		$totalvotes += int($votes[$i]);
		if (int($votes[$i]) >= $maxvote) { $maxvote = int($votes[$i]); }
	}
	$piearray =~ s/\, $//i;
	$piearray .= qq~]~;
</replace>

<search for>
     <td valign="top" class="catbg">
	<div style="width: 100%;">
		<b>$polltxt{'16'}:</b> $poll_question<br />
	</div>
</td>
</search for>

<replace>
     <td valign="top" class="catbg">
	<div style="float: left; width: 80%;">
		<b>$polltxt{'16'}:</b> $poll_question
	</div>
	~;
	if($has_voted) {
		unless($hide_results && !$poll_locked) {
			$pollmain .= qq~
			<div style="float: left; width: 20%; text-align: right;">
				<script language="JavaScript1.2" type="text/javascript">
				<!--
				document.write('<a href="$scripturl?num=$viewnum"><img src="$modimgurl/pollpie/bars.gif" border="0" alt="" /></a>');
				document.write('<a href="$scripturl?num=$viewnum;view=pie"><img src="$modimgurl/pollpie/pie.gif" border="0" alt="" /></a>');
				//-->
				</script>
			</div>
			~;
		}
	}
	$pollmain .= qq~
</td>
</replace>

<search for>
    <div style="width: 100%;"><br />~;
</search for>

<replace>
    <div class="$bgclass" id="piestyle" style="width: 100%;"><br />~;
</replace>

<search for>
		for ($i = 0; $i < @options; $i++) {

			unless ($options[$i]) { next; }

			# Censor the options.
			$options[$i] = &Censor($options[$i]);
			$options[$i] =~ s~[\n\r]~~g;
			if ($ubbcpolls) {
				if (!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
				$message = $options[$i];
				&DoUBBC;
				$options[$i] = $message;
			}
			&ToChars($options[$i]);

			if ($has_voted) {

				# Display Poll Results
				$pollpercent = 0;
				$pollbar     = 0;
				if ($totalvotes ne 0 && $maxvote ne 0) {
					$pollpercent = int(1000 * $votes[$i] / $totalvotes);
					$pollpercent = $pollpercent / 10;
					$pollbar = int(150 * $votes[$i] / $maxvote);
				}

				$pollmain .= qq~
				<div style="clear: both;">
                <div style="float: left; width: 50%; text-align: right;"><b>$options[$i]&nbsp;&nbsp;</b></div>
                <div style="float: left; text-align: left;">&nbsp;<img src="$imagesdir/poll_left.gif" height="12" align="middle" alt="" /><img src="$imagesdir/poll_middle.gif" height="12" width="$pollbar" align="middle" alt="" /><img src="$imagesdir/poll_right.gif" height="12" align="middle" alt="" /> $votes[$i] ($pollpercent%)</div>
				</div>~;

			} else {

				# Display Poll Options
				if ($multi_vote) { $input = qq~<input type="checkbox" name="option$i" value="$i" />~; }
				else { $input = qq~<input type="radio" name="option" value="$i" />~; }

				$pollmain .= qq~
				<div style="clear: both;">
                <div style="float: left; width: 25px; text-align: right;">$input</div>
                <div style="float: left; text-align: left;"><b>$options[$i]</b></div>
				</div>~;

			}
		}
</search for>

<replace>
		if($has_voted) {
			if($INFO{'view'} eq "pie") {
				$pollmain .= qq~
				<script language="JavaScript1.2" src="$html_root/piechart.js" type="text/javascript"></script>
				<script language="JavaScript1.2" type="text/javascript">
				<!--
				if (document.getElementById('piestyle').currentStyle) {
					pie_colorstyle = document.getElementById('piestyle').currentStyle['color'];
				} else if (window.getComputedStyle) {
					var compStyle = window.getComputedStyle(document.getElementById('piestyle'), "");
					pie_colorstyle = compStyle.getPropertyValue('color');
				}
				else pie_colorstyle = "#000000";

				var pie = new pieChart();
				pie.pie_array = $piearray;
				pie.radius = $pie_radius;
				pie.use_legends = $pie_legends;
				pie.color_style = pie_colorstyle;
				pie.sliceAdd();
				//-->
				</script>
				~;
			}
			else {
				for ($i = 0; $i < @options; $i++) {
					unless ($options[$i]) { next; }
					# Display Poll Results
					$pollpercent = 0;
					$pollbar     = 0;
					if ($totalvotes > 0 && $maxvote > 0) {
						$pollpercent = (100 * $votes[$i]) / $totalvotes;
						$pollpercent = sprintf("%.1f", $pollpercent);
						$pollbar = int(150 * $votes[$i] / $maxvote);
					}
					$pollbar .= 'px';
					$pollmain .= qq~
					<div style="clear: both; height: 18px; vertical-align: middle;">
					<div style="float: left; width: 50%; text-align: right;">$options[$i]&nbsp;&nbsp;&nbsp;&nbsp;</div>
					<div style="float: left; text-align: left; width: $pollbar; height: 10px; background-color: $slicecolor[$i]; border: 1px outset $slicecolor[$i];"></div>
					<div class="small" style="float: left; text-align: left;">&nbsp;&nbsp;$votes[$i] ($pollpercent%)</div>
					</div>~;
				}
			}
		}
		else {
			for ($i = 0; $i < @options; $i++) {
				unless ($options[$i]) { next; }
				# Display Poll Options
				if ($multi_vote) { $input = qq~<input type="checkbox" name="option$i" id="option$i" value="$i" style="margin: 0; padding: 0; vertical-align: middle;" />~; }
				else { $input = qq~<input type="radio" name="option" id="option$i" value="$i" style="margin: 0; padding: 0; vertical-align: middle;" />~; }
				$pollmain .= qq~
				<div style="clear: both;">
				<div style="float: left; height: 22px; text-align: right;">$input <label for="option$i"><b>$options[$i]</b></label></div>
				</div>~;
			}
		}
</replace>


<Edit file>
Sources/Post.pl
</Edit file>

<search for>
<table border="0" width="100%" cellpadding="3" cellspacing="0" class="windowbg" style="table-layout: fixed;">

	~;

	if ($pollthread) {
		$maxpq          ||= 60;
		$maxpo          ||= 50;
		$maxpc          ||= 0;
		$numpolloptions ||= 8;
		$vote_limit     ||= 0;

		if ($guest_vote)   { $gvchecked = ' checked="checked"'; }
		if ($hide_results) { $hrchecked = ' checked="checked"'; }
		if ($multi_choice) { $mcchecked = ' checked="checked"'; }

		$yymain .= qq~
		<tr>
                <td width="23%" align="right" class="windowbg2"><b>$post_polltxt{'6'}:</b> &nbsp;</td>
                <td width="77%" align="left"  class="windowbg2">
			<input type="text" size="50" name="question" value="$poll_question" maxlength="$maxpq" />
			<input type="hidden" name="pollthread" value="$pollthread" />
		</td>
		</tr>~;

		for (my $i = 1; $i <= $numpolloptions; $i++) {
			$yymain .= qq~
                    <tr>
                      <td width="23%" align="right" class="windowbg2"> &nbsp; $post_polltxt{'7'} $i: &nbsp;</td>
                      <td width="77%" align="left" class="windowbg2"><input type="text" size="35" maxlength="$maxpo" name="option$i" value="$options[$i]" /></td>
                    </tr>~;
		}

		if ($maxpc > 0) {
			$yymain .= qq~
		<tr>
                <td valign=top class="windowbg2" width="23%"><b>$post_polltxt{'59'}:</b></td>
                <td class="windowbg2" width="77%"><textarea name="poll_comment" rows="3" cols="60" wrap="soft" onkeyup="if (document.postmodify.poll_comment.value.length > $maxpc) {document.postmodify.poll_comment.value = document.postmodify.poll_comment.value.substring(0,$maxpc)}">$poll_comment</textarea></td>
		</tr>~;
		}

		$yymain .= qq~
		<tr>
                <td width="23%" align="left"><b>$post_polltxt{'32'}</b></td>
                <td width="77%" align="left"><input type="checkbox" name="guest_vote" value="1"$gvchecked /> <span  class="small">$post_polltxt{'54'}</span></td>
              </tr><tr>
                <td width="23%" align="left"><b>$post_polltxt{'26'}</b></td>
                <td width="77%" align="left"><input type="checkbox" name="hide_results" value="1"$hrchecked /> <span  class="small">$post_polltxt{'55'}</span></td>
              </tr><tr>
                <td width="23%" align="left"><b>$post_polltxt{'58'}</b></td>
                <td width="77%" align="left"><input type="checkbox" name="multi_choice" value="1"$mcchecked /> <span  class="small">$post_polltxt{'56'}</span></td>
              </tr><tr>
                <td width="23%" align="left"><b>$post_polltxt{'60'}</b></td>
                <td width="77%" align="left"><input type="text" size="6" name="vote_limit" value="$vote_limit" /> <span  class="small">$post_polltxt{'61'}</span></td>
              </tr>
~;
	}



if($postid ne 'Poll') {
</search for>

<replace>
	~;

	if ($pollthread) {
		$maxpq          ||= 60;
		$maxpo          ||= 50;
		$maxpc          ||= 0;
		$numpolloptions ||= 8;
		$vote_limit     ||= 0;
		$pie_radius	||= 100;

		if ($guest_vote)   { $gvchecked = ' checked="checked"'; }
		if ($hide_results) { $hrchecked = ' checked="checked"'; }
		if ($multi_choice) { $mcchecked = ' checked="checked"'; }
		if ($pie_legends) { $legchecked = ' checked="checked"'; }

		$yymain .= qq~
		<table border="0" width="100%" cellpadding="3" cellspacing="0" class="windowbg" style="table-layout: fixed;">
		<tr>
			<td width="250" class="catbg"><b>$post_polltxt{'6'}:</b></td>
			<td width="240" class="catbg">&nbsp;</td>
			<td width="60" class="catbg">&nbsp;</td>
			<td width="60" class="catbg">&nbsp;</td>
			<td class="catbg">&nbsp;</td>
		</tr>
		<tr>
			<td class="windowbg2" colspan="5" style="font-size: 3px;">&nbsp;</td>
		</tr>
		<tr>
                <td align="left" class="windowbg2">&nbsp;</td>
                <td colspan="4" align="left" class="windowbg2">
			<input type="text" size="60" name="question" value="$poll_question" maxlength="$maxpq" />
			<input type="hidden" name="pollthread" value="$pollthread" />
		</td>
		</tr>
		<tr>
			<td class="windowbg2" colspan="5" style="font-size: 3px;">&nbsp;</td>
		</tr>
		<tr>
			<td align="left" class="catbg"><b>$post_polltxt{'polloptions'}</b></td>
			<td align="left" class="catbg"><b>$post_polltxt{'polloptionstext'}</b></td>
			<td align="center" class="catbg"><b>$post_polltxt{'pieslicecolor'}</b></td>
			<td align="center" class="catbg"><b>$post_polltxt{'pieslicesplit'}</b></td>
			<td class="catbg">&nbsp;</td>
		</tr>
		<tr>
			<td class="windowbg2" colspan="5" style="font-size: 3px;">&nbsp;</td>
		</tr>

		~;

		$piecolarray = qq~["",~;
		for (my $i = 1; $i <= $numpolloptions; $i++) {
			if ($split[$i]) { $splitchecked[$i] = ' checked="checked"'; }
			if($FORM{"slicecol$i"}) { $slicecolor[$i] = $FORM{"slicecol$i"}; }
			$yymain .= qq~
                    <tr>
                      <td align="right" class="windowbg2"> &nbsp; $post_polltxt{'7'} $i: &nbsp;</td>
                      <td align="left" class="windowbg2">
				<input type="text" size="35" maxlength="$maxpo" name="option$i" value="$options[$i]" />
			</td>
			<td align="center" class="windowbg2">
				<input type="text" size="3" name="slicecolor$i" id="slicecolor$i" value="" style="background-color: $slicecolor[$i]; border: 1px outset $slicecolor[$i]; cursor: pointer;" readonly="readonly" onclick="getSlicecolor($i)" />
				<input type="hidden" name="slicecol$i" id="slicecol$i" value="$slicecolor[$i]" />
			</td>
			<td align="center" class="windowbg2">
				<input type="checkbox" name="split$i" value="1"$splitchecked[$i] /> <span  class="small">$post_polltxt{'splitslice'}</span>
			</td>
			<td align="left" class="windowbg2">
				&nbsp;
			</td>
                    </tr>~;
			$piecolarray .= qq~"$slicecolor[$i]", ~;
		}
		$piecolarray =~ s/\, $//i;
		$piecolarray .= qq~]~;
		$yymain .= qq~

		<script language="JavaScript1.2" type="text/javascript">
		<!--

		var tmpslicecolor;
		var itohex = ["0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F"];
		var slice_col = $piecolarray;
		var defslice_col = new Array();
		function tohex(i) {
			a2 = ''
			ihex = Math.floor(eval(i +'/16'));
			idiff = eval(i + '-(' + ihex + '*16)')
			a2 = itohex[idiff] + a2;
			while( ihex >= 16) {
				itmp = Math.floor(eval(ihex +'/16'));
				idiff = eval(ihex + '-(' + itmp + '*16)');
				a2 = itohex[idiff] + a2;
				ihex = itmp;
			} 
			a1 = itohex[ihex];
			return a1 + a2;
		}

		for (var tz = 0; tz < 256; tz += 63)
			for (var ty = 0; ty < 256; ty += 85)
				for (var tx = 0; tx < 256; tx += 127) defslice_col.push('#' + tohex(tx) + tohex(ty) + tohex(tz));

		for(var i = 1; i <= $numpolloptions; i++) {
			if(!slice_col[i]) slice_col[i] = defslice_col[i]
			document.getElementById('slicecolor' + i).style.backgroundColor = slice_col[i];
			document.getElementById('slicecolor' + i).style.borderColor = slice_col[i];
			document.getElementById('slicecol' + i).value = slice_col[i];
		}

		function getSlicecolor(slicenum) {
			tmpslicecolor = slicenum;
			window.open('$scripturl?action=palette;task=templ', '', 'height=308,width=302,menubar=no,toolbar=no,scrollbars=no');
		}

		function previewColor(newsilcecolor) {
			document.getElementById('slicecolor' + tmpslicecolor).style.backgroundColor = newsilcecolor;
			document.getElementById('slicecolor' + tmpslicecolor).style.borderColor = newsilcecolor;
			document.getElementById('slicecol' + tmpslicecolor).value = newsilcecolor;
		}
		//-->
		</script>
		~;

		if ($maxpc > 0) {
			$yymain .= qq~
		<tr>
                <td valign=top class="windowbg2"><b>$post_polltxt{'59'}:</b></td>
                <td class="windowbg2" colspan="4"><textarea name="poll_comment" rows="3" cols="60" wrap="soft" onkeyup="if (document.postmodify.poll_comment.value.length > $maxpc) {document.postmodify.poll_comment.value = document.postmodify.poll_comment.value.substring(0,$maxpc)}">$poll_comment</textarea></td>
		</tr>~;
		}

		$yymain .= qq~
		<tr>
			<td class="windowbg2" colspan="5" style="font-size: 3px;">&nbsp;</td>
		</tr>
		<tr>
                <td align="left" valign="top"><b>$post_polltxt{'32'}</b></td>
                <td align="left" valign="top" colspan="4"><input type="checkbox" name="guest_vote" value="1"$gvchecked /> <span  class="small">$post_polltxt{'54'}</span></td>
              </tr><tr>
                <td align="left" valign="top"><b>$post_polltxt{'26'}</b></td>
                <td align="left" valign="top" colspan="4"><input type="checkbox" name="hide_results" value="1"$hrchecked /> <span  class="small">$post_polltxt{'55'}</span></td>
              </tr><tr>
                <td align="left" valign="top"><b>$post_polltxt{'58'}</b></td>
                <td align="left" valign="top" colspan="4"><input type="checkbox" name="multi_choice" value="1"$mcchecked /> <span  class="small">$post_polltxt{'56'}</span></td>
              </tr><tr>
                <td align="left" valign="top"><b>$post_polltxt{'60'}</b></td>
                <td align="left" valign="top" colspan="4"><input type="text" size="6" name="vote_limit" value="$vote_limit" /> <span  class="small">$post_polltxt{'61'}</span></td>
              </tr>
		<tr>
                <td align="left" valign="top"><b>$post_polltxt{'pielegends'}</b></td>
                <td align="left" valign="top" colspan="4"><input type="checkbox" name="pie_legends" value="1"$legchecked /> <span  class="small">$post_polltxt{'pielegends_descr'}</span></td>
		</tr>
		<tr>
                <td align="left" valign="top"><b>$post_polltxt{'pieradius'}</b></td>
                <td align="left" valign="top" colspan="4"><input type="text" size="4" name="pie_radius" value="$pie_radius" /> <span  class="small">$post_polltxt{'pieradius_descr'}</span></td>
		</tr>
		</table>
~;
	}


	$yymain .= qq~
<table border="0" width="100%" cellpadding="3" cellspacing="0" class="windowbg" style="table-layout: fixed;">
	~;


if($postid ne 'Poll') {
</replace>

<search for>
	$vote_limit ||= 0;
</search for>

<add after>
	$pie_radius ||= 100;
</add after>

<search for>
	for (my $i = 1; $i <= $numpolloptions; $i++) {
		$options[$i] = $FORM{"option$i"};
		&FromHTML($options[$i]);
		&FromChars($options[$i]);
		$convertstr = $options[$i];
		$convertcut = $maxpo;
		&CountChars;
		$options[$i] = $convertstr;
		&ToHTML($options[$i]);
	}
</search for>

<replace>
	for (my $i = 1; $i <= $numpolloptions; $i++) {
		$options[$i] = $FORM{"option$i"};
		&FromHTML($options[$i]);
		&FromChars($options[$i]);
		$convertstr = $options[$i];
		$convertcut = $maxpo;
		&CountChars;
		$options[$i] = $convertstr;
		&ToHTML($options[$i]);
		$slicecolor[$i] = $FORM{"slicecol$i"};
		$split[$i] = $FORM{"split$i"};
	}
</replace>

<search for>
	$vote_limit   = $FORM{'vote_limit'};
</search for>

<add after>
	$pie_legends  = $FORM{'pie_legends'};
	$pie_radius   = $FORM{'pie_radius'};

	if ($pie_radius =~ /\D/) { $pie_radius = 100; }
	if ($pie_radius < 100) { $pie_radius = 100; }
	if ($pie_radius > 200) { $pie_radius = 200; }
</add after>

<search for>
		$vote_limit   = $FORM{'vote_limit'}   || 0;
</search for>

<add after>
		$pie_legends  = $FORM{'pie_legends'}  || 0;
		$pie_radius   = $FORM{'pie_radius'}   || 100;

		if ($pie_radius =~ /\D/) { $pie_radius = 100; }
		if ($pie_radius < 100) { $pie_radius = 100; }
		if ($pie_radius > 200) { $pie_radius = 200; }
</add after>

<search for>
		push @poll_data, qq~$FORM{"question"}|0|$username|$name|$email|$date|$guest_vote|$hide_results|$multi_choice|||$poll_comment|$vote_limit\n~;
</search for>

<replace>
		push @poll_data, qq~$FORM{"question"}|0|$username|$name|$email|$date|$guest_vote|$hide_results|$multi_choice|||$poll_comment|$vote_limit|$pie_radius|$pie_legends\n~;
</replace>

<search for>
				push @poll_data, qq~0|$FORM{"option$i"}\n~;
</search for>

<replace>
				$split[$i] = $FORM{"split$i"} || 0;
				push @poll_data, qq~0|$FORM{"option$i"}|$FORM{"slicecol$i"}|$split[$i]\n~;
</replace>
